/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TriggerSettings'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TriggerSettings'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.ReplicationTrigger = factory(root.HarborApi.ApiClient, root.HarborApi.TriggerSettings);
  }
}(this, function(ApiClient, TriggerSettings) {
  'use strict';

  /**
   * The ReplicationTrigger model module.
   * @module model/ReplicationTrigger
   * @version 2.0
   */

  /**
   * Constructs a new <code>ReplicationTrigger</code>.
   * @alias module:model/ReplicationTrigger
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>ReplicationTrigger</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ReplicationTrigger} obj Optional instance to populate.
   * @return {module:model/ReplicationTrigger} The populated <code>ReplicationTrigger</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('type'))
        obj.type = ApiClient.convertToType(data['type'], 'String');
      if (data.hasOwnProperty('trigger_settings'))
        obj.triggerSettings = TriggerSettings.constructFromObject(data['trigger_settings']);
    }
    return obj;
  }

  /**
   * The replication policy trigger type. The valid values are manual, event_based and scheduled.
   * @member {String} type
   */
  exports.prototype.type = undefined;

  /**
   * @member {module:model/TriggerSettings} triggerSettings
   */
  exports.prototype.triggerSettings = undefined;


  return exports;

}));
